-- Copyright (c) 2024 Huawei Technologies Co., Ltd.
-- openUBMC is licensed under Mulan PSL v2.
-- You can use this software according to the terms and conditions of the Mulan PSL v2.
-- You may obtain a copy of Mulan PSL v2 at:
--         http://license.coscl.org.cn/MulanPSL2
-- THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
-- EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
-- MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
-- See the Mulan PSL v2 for more details.

local skynet = require 'skynet'
require 'skynet.manager'
local logging = require 'mc.logging'
local PCIeDeviceApp = require 'pcie_device_app'

local app = nil
local CMD = {}

function CMD.exit()
  logging:info('pcie_device service exit')
end

skynet.start(function()
  skynet.uniqueservice('sd_bus')
  skynet.register('pcie_device')
  app = PCIeDeviceApp.new()
  app:main()
  skynet.dispatch('lua', function(_, _, cmd, ...)
    local f = assert(CMD[cmd])
    skynet.ret(skynet.pack(f(...)))
  end)
end)
